package graph;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class ControlPanel extends
        Panel implements
        ActionListener, ItemListener {

    private GraphPanel graphPanel =
            new GraphPanel(this);

    private Button scrambleButton =
            new Button("Scramble");
    private Button shakeButton =
            new Button("Shake");
    private Checkbox stressCheckbox =
            new Checkbox("Stress");
    private Checkbox randomCheckbox =
            new Checkbox("Random");

    private Panel controlPanel = getControlPanel();

    public void Graph() {
        initComponents();
        Dimension d = getSize();
    }

    public void addEdge(String e1, String e2) {
        graphPanel.addEdge(e1, e2);
    }

    public GraphPanel getGraphPanel() {
        return graphPanel;
    }


    private void initComponents() {
        setLayout(new BorderLayout());
        add("South", controlPanel);
        add("Center", graphPanel);
    }

    public Panel getControlPanel() {
        Panel p = new Panel();
        scrambleButton.addActionListener(this);
        shakeButton.addActionListener(this);
        stressCheckbox.addItemListener(this);
        randomCheckbox.addItemListener(this);
        p.setLayout(new FlowLayout());
        addComponentsToPanel(p);
        return p;
    }

    private void addComponentsToPanel(Panel p) {
        p.add(scrambleButton);
        p.add(shakeButton);
        p.add(stressCheckbox);
        p.add(randomCheckbox);
    }

    public void start() {
        graphPanel.start();
    }

    public void actionPerformed(ActionEvent e) {
        Object src = e.getSource();
        if (src == scrambleButton)
            scrambleNodes();
        if (src == shakeButton)
            shakeNodes();
    }

    private void shakeNodes() {
        Dimension d = getSize();
        for (int i = 0; i < graphPanel.getNnodes(); i++) {
            Node n = graphPanel.getNodes()[i];
            if (n.isFixed()) return;
            n.setX(n.getX()
                    + (80 * Math.random() - 40));
            n.setY(n.getY()
                    + (80 * Math.random() - 40));
        }
    }

    private void scrambleNodes() {
        Dimension d = getSize();
        for (int i = 0; i < graphPanel.getNnodes(); i++) {
            Node n = graphPanel.getNodes()[i];
            if (!n.isFixed()) {
                n.setX(10 + (d.width - 20) * Math.random());
                n.setY(10 + (d.height - 20) * Math.random());
            }
        }
    }

    public void itemStateChanged(ItemEvent e) {
        Object src = e.getSource();
        boolean on = e.getStateChange() ==
                ItemEvent.SELECTED;
        if (src == stressCheckbox)
            graphPanel.setStress(on);
        if (src == randomCheckbox)
            graphPanel.setRandom(on);
    }

}
