/**
 *
 * @author D. Lyon
 * @version 1.0
 * Date: Mar 31, 2002
 * Time: 10:43:27 AM
 */
package graph;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public class MouseManipulations extends NodesAndEdges implements MouseListener, MouseMotionListener {
    //1.1 event handling
    public void mouseClicked(MouseEvent e) {
        setFixedNode(e);
    }

    public void mousePressed(MouseEvent e) {
        addListeners();
        setFixedNode(e);
        repaint();
        e.consume();
    }

    private void setFixedNode(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        selectANode(x, y);
        setPickfixed(pick.isFixed());
        pick.setFixed(true);
        pick.setX(x);
        pick.setY(y);
    }

    private void selectANode(int x, int y) {
        double bestdist = Double.MAX_VALUE;
        for (int i = 0; i < nnodes; i++) {
            Node n = nodes[i];
            double dist
                    = (n.getX() - x) * (n.getX() - x)
                    + (n.getY() - y) * (n.getY() - y);
            if (dist < bestdist) {
                pick = n;
                bestdist = dist;
            }
        }
    }

    private void addListeners() {
        addMouseMotionListener(this);
    }

    public void mouseReleased(MouseEvent e) {
        removeMouseMotionListener(this);
        if (pick != null) {
            pick.setX(e.getX());
            pick.setY(e.getY());
            pick.setFixed(isPickfixed());
            pick = null;
        }
        repaint();
        e.consume();
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseDragged(MouseEvent e) {
        pick.setX(e.getX());
        pick.setY(e.getY());
        repaint();
        e.consume();
    }

    public void mouseMoved(MouseEvent e) {
    }
}
