package graph;

import java.awt.*;

class Node {
    private double x;
    private double y;

    private double dx;
    private double dy;

    private boolean fixed;

    private String lbl;

    public double getX() {
        return x;
    }

    public void incrementDxDy(double _dx, double _dy) {
        dx = dx + _dx;
        dy = dy + _dy;
    }

    /**
     * push node by small amount on screen
     */
    public void nuge() {
        double nodeX = getX();
        setX(nodeX
                + Math.max(-5,
                        Math.min(
                                5,
                                getDx())));
        double nodeY = getY();
        setY(nodeY
                + Math.max(-5,
                        Math.min(5, getDy())));
    }

    /**
     * ceilingNode makes sure that node
     * does not exceed a given dimension
     */
    public void ceilingNode(Dimension d) {
        if (getX() > d.width)
            setX(d.width);
        if (getY() > d.height)
            setY(d.height);
    }

    /**
     * cut dx and dy by one half
     * @author D. Lyon
     */
    public void oneHalfDxDy() {
        setDx(getDx() / 2);
        setDy(getDy() / 2);
    }

    public void setX(double _x) {
        x = _x;
        if (x < 0) x = 0;
    }

    public double getY() {
        return y;
    }

    public void setY(double _y) {
        y = _y;
        if (y < 0) y = 0;
    }

    public double getDx() {
        return dx;
    }

    public void setDx(double dx) {
        this.dx = dx;
    }

    public double getDy() {
        return dy;
    }

    public void setDy(double dy) {
        this.dy = dy;
    }

    public boolean isFixed() {
        return fixed;
    }

    public void setFixed(boolean fixed) {
        this.fixed = fixed;
    }

    public String getLbl() {
        return lbl;
    }

    public void setLbl(String lbl) {
        this.lbl = lbl;
    }
}