/*
 */
package graph;

public class NodesAndEdges extends NodeProperties {
    protected int nnodes;
    protected Node nodes[] = new Node[100];
    protected int nedges;
    protected Edge edges[] = new Edge[200];
    protected Node pick;

    public Node[] getNodes() {
        return nodes;
    }

    public int getNnodes() {
        return nnodes;
    }

    int findNode(String lbl) {
        for (int i = 0; i < nnodes; i++)
            if (nodes[i].getLbl().equals(lbl))
                return i;
        return addNode(lbl);
    }

    int addNode(String lbl) {
        Node n = new Node();
        n.setX(50 + 380 * Math.random());
        n.setY(50 + 380 * Math.random());
        n.setLbl(lbl);
        nodes[nnodes] = n;
        return nnodes++;
    }

    public void addEdge(String e1, String e2) {
        addEdge(e1, e2, 50);
    }

    void addEdge(String from, String to, int len) {
        Edge e = new Edge();
        e.setFrom(findNode(from));
        e.setTo(findNode(to));
        e.setLen(len);
        edges[nedges++] = e;
    }

    protected void setupEdges() {
        for (int i = 0; i < nedges; i++) {
            Edge e = edges[i];
            double vx = nodes[e.getTo()].getX()
                    - nodes[e.getFrom()].getX();
            double vy = nodes[e.getTo()].getY()
                    - nodes[e.getFrom()].getY();
            double len = Math.sqrt(vx * vx + vy * vy);
            len = (len == 0) ? .0001 : len;
            double f = (edges[i].getLen() - len)
                    / (len * 3);
            double dx = f * vx;
            double dy = f * vy;

            nodes[e.getTo()].incrementDxDy(dx, dy);
            nodes[e.getFrom()].incrementDxDy(-dx, -dy);
        }
    }
}
